import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Method;
import java.util.InputMismatchException;
import java.util.Scanner;
import java.util.Vector;


public class controller {

	static Scanner input = new Scanner(System.in);
	
	static public String projectname = new String();
	static public Vector<String> targets = new Vector<String>();
	static public Vector<String> modules = new Vector<String>();
	

	public static void setProjectName() {		
		boolean success = false;
		String temp = new String();
		
		
		while (!success) {
			System.out.println("Project name:\n");
			temp = input.next();
			if (new File("project\\" + temp).exists()) {
				System.out.println("Project already exists, do you want to remove the existant projecct? [Yes] or [No]");
				String confirmation = input.next();
					if (confirmation.contains("Yes")||confirmation.contains("yes")){
						utils.deleteFolder(new File ("project\\" + temp));
						success = true;
						projectname = temp;
				}				
			} else { 
				success = true;
				projectname = temp;
			}
		}		
	}
	
	
	public static void targetList (){
		
		int option = 0;
		boolean end = false;
		String text = new String();
		
		while (option!=1&&option!=2) {		
			System.out.println("Choose method to enter the targets");
			System.out.println("1) get targets from servers.txt");
			System.out.println("2) set targets manually");		
			
			try { option = input.nextInt(); } 
			catch (InputMismatchException e) { System.out.println(input.next() + " is not a valid option"); }
		}
			
		if (option==1) {
			try{
				File file = new File ("servers.txt"); 
				FileReader fr = new FileReader (file);
				BufferedReader br = new BufferedReader(fr);
				while (br.ready()) {
					targets.add(br.readLine());
				}		
				br.close();
			} catch (FileNotFoundException e) {
				System.out.println("File not found. Make sure servers.txt exists in the progrm folder");
				e.printStackTrace();
			} catch (IOException e) {
				System.out.println("There was a problem reading the file");
				e.printStackTrace();
			}
			
		}
		if (option==2) {
			
			System.out.println("Insert the domains one by one. Insert 0 to finish adding domains");
			while (!end){
				text = input.next();
				if (text.equals("0")) end = true;
				else targets.add(text);
			}			
		}		
	}
	
	public static void loadModules() {		
		int counter=0;
		boolean end = false;
		boolean error = false;
		int intro = 0;
		Vector<String> modulename = new Vector<String>();
		Vector<String> moduledescription = new Vector<String>();

		
		String file = "modules.txt";
		BufferedReader br = null;
		String line = "";
		String cvsSplitBy = ",";
		
		try {
			br = new BufferedReader(new FileReader(file));

			while ((line = br.readLine()) != null) {
				String[] module = line.split(cvsSplitBy);
				modulename.addElement(module[0]);
				moduledescription.addElement(module[1]);			
			}
	    } catch (Exception e) { e.printStackTrace(); }
		
		System.out.println("This is the list of current modules. Choose the modules you want to use. Insert 0 to finish adding modules");
		for (int j=0;j<modulename.size();j++) {
			System.out.println(j+1 + ") " + modulename.get(j) + " - " + moduledescription.get(j));
		}
		
		while (!end){
			error = false;
			
			try { intro = input.nextInt(); } 
			catch (InputMismatchException e) { 
				System.out.println(input.next() + " is not a valid module"); 
				error = true;
			}
			
			if (!error) {
				if (intro == 0) end = true;
				else if (intro<=modulename.size()) {
					modules.add(modulename.get(intro-1));
				} else {
					 System.out.println("Error: module not available");
					 error = true;
				} 				
				if (!error) {
					if (intro!=0) System.out.println("Module " + modules.elementAt(counter) + " selected, insert 0 to finish or insert another module number");
					counter++;	
				}
			}
		}			
		
		//Improvements: check if the module has already been choosen
	}

	public static void runModules() {		
		
		int i = 0;
		
		while (i<modules.size()) {
			try {
				Object module = Class.forName(modules.elementAt(i)).newInstance();
				Method m = module.getClass().getDeclaredMethod("run", new Class<?>[0]);
				m.invoke(module);
				
			} catch (Exception e) { e.printStackTrace(); }
			i++;
		}
		//Improvements: Investigate security implications related to this method and usage of reflection
	}

	public static void createProjectFiles() {		
		int i = 0;
		
		String projectpath = "project\\" + projectname;
		
		new File(projectpath).mkdirs();
		while (i<targets.size()) {
			new File(projectpath + "\\" + targets.elementAt(i)).mkdirs();
			i++;
		}
		
		PrintWriter writer;
		try {
			writer = new PrintWriter(projectpath + "\\project_summary.txt", "UTF-8");
			writer.println("PROJECT SUMMARY");
			writer.println("Project name: " + projectname);
			writer.println("");
			writer.println("Target list:");
			i=0;
			while (i<targets.size()) {
				writer.println(i + " - " + targets.elementAt(i));
				i++;
			}
			writer.println("");
			writer.println("Modules choosen:");
			i=0;
			while (i<modules.size()) {
				writer.println(i + " - " + modules.elementAt(i));
				i++;
			}

			writer.close();
					
		} catch (FileNotFoundException | UnsupportedEncodingException e) {
			e.printStackTrace();
		} 
		
	}

	
	public static void main(String[] args) {
		//APPLICATION FLOW
			
		//1 - Set project name
		setProjectName();
		
		//2 - Get target info
		targetList();
		
		//3 - Load modules
		loadModules();
		
		//4 - Create folder and info files
		createProjectFiles();		
		
		//5 - Run modules
		runModules();
	}

}
