import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class httperror {

	static http http = new http();
	static PrintWriter errorsummary;
	
	static void dohtmlfile(String target,String filename) {
			
		String path = "project\\" + controller.projectname + "\\" + target;
		PrintWriter htmlfile;
		
		try { 
			htmlfile = new PrintWriter(path + "\\" + filename); 
			htmlfile.print(http.responseHTML);
			htmlfile.close();
			
		} 
		catch (FileNotFoundException e1) { e1.printStackTrace(); }
		
				
	}

	static String searchVersion() {
		
		File serverstrings = new File("httperror_serverstrings.txt");
		BufferedReader br = null;
		String serverstring = "";
		int index = 0;
		
		try {
			br = new BufferedReader(new FileReader(serverstrings));
			while ((serverstring = br.readLine()) != null) {
				if (http.responseHTML.contains(serverstring)) {
					index = http.responseHTML.indexOf(serverstring);
					br.close();
					return http.responseHTML.substring(index,http.responseHTML.indexOf("<",index));
				}
			}
			
		} catch (IOException e) { e.printStackTrace();} 

		return "not found";
	}
	
	static void checkServerString(String serverstring) {
		
		File serverstrings = new File("httperror_serverstrings.txt");
		BufferedReader br = null;
		String newline = new String();
		boolean stringexists = false;
		Scanner input = new Scanner(System.in);
		
		while (serverstring.contains("/")) serverstring=serverstring.substring(0, http.responseServer.indexOf("/"));
		while (serverstring.contains(".")) serverstring=serverstring.substring(0, http.responseServer.indexOf("."));

		try {
			br = new BufferedReader(new FileReader(serverstrings));
			while ((newline = br.readLine()) != null && !stringexists) {
				if ( newline.equals(serverstring) ) stringexists = true;
			}
			
			if (!stringexists) {
				System.out.println("Located a new server string: " + serverstring);
				System.out.println("Do you want to add this string to the httperror_serverstrings.txt file? [Yes] [No]");
				String confirmation = input.next();
				if (confirmation.equals("Yes")||confirmation.equals("yes")) {
					try {
					    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("httperror_serverstrings.txt", true)));
					    out.println(serverstring);
					    out.close();
					} catch (IOException e) {
					    e.printStackTrace();
					}
				}
				
				
			}
			
		} catch (IOException e) { e.printStackTrace();} 

	}

	
	static void writeSummary(String target,String comments,String method) {
		errorsummary.print(target);
		errorsummary.print(",");
		errorsummary.print(method);
		errorsummary.print(",");
		errorsummary.print(Integer.toString(http.responseCode));
		errorsummary.print(",");
		errorsummary.print(http.responseServer);
		errorsummary.print(",");
		if (method!="StandardRequest") errorsummary.print(searchVersion());
		errorsummary.print(",");
		errorsummary.println(comments);
	}
 	
	static void runStandardRequest(String target) {
		String comments = new String();
		http.httpThroguhSocket(target,80, "GET / HTTP/1.1\r\nhost: " + target + "\r\n",0);
		
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			if (http.responseCode==302||http.responseCode==303) comments = "Probably redirected by a LoadBalancer to a local website";			
			checkServerString(http.responseServer);
			writeSummary(target,comments,"StandardRequest");	
			dohtmlfile(target,http.responseCode + ".html");
		}
	
	}
	
	static void runNotFound(String target) {
		String comments = new String();
		http.httpThroguhSocket(target,80, "GET /index95381.html HTTP/1.1\r\nhost:" + target + "\r\n",0);

		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"NotFound");		
			dohtmlfile(target,http.responseCode + ".html"); 	
 
		}



	}
	
	static void runMethodNotValid(String target) {
	
		String comments = new String();
	
		http.httpThroguhSocket(target,80, "DELETE / HTTP/1.1\r\nhost:" + target + "\r\n",0);
		
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"MethodNotValid");	
			dohtmlfile(target,http.responseCode + ".html");
		}

		http.httpThroguhSocket(target,80, "TRACE / HTTP/1.1\r\nhost:" + target + "\r\n",0);
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"MethodNotValid");	
			dohtmlfile(target,http.responseCode + ".html");
		}

		http.httpThroguhSocket(target,80, "RENAMEA / HTTP/1.1\r\nhost:" + target + "\r\n",0);
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"MethodNotValid");	
			dohtmlfile(target,http.responseCode + ".html");
		}

	}
	
	static void runBadRequest(String target) {
		String comments = new String();
	
		http.httpThroguhSocket(target,80, "GET \\ HTTP/1.1\r\nhost:" + target + "\r\n",0);
		
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"BadRequest");	
			dohtmlfile(target,http.responseCode + ".html");
		}

		http.httpThroguhSocket(target,80, "GETHTTP1.1\r\nhost:" + target + "\r\n",0);
		
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"BadRequest");	
			dohtmlfile(target,http.responseCode + ".html");
		}


	}
	
	static void runTimeOut(String target) {
		String comments = new String();
		http.responseCode=0;
		http.responseServer="empty response";
		http.responseHTML="empty response";
		http.responsefull="empty response";
		
		http.httpThroguhSocket(target,80, "GET / HTTP/1.1",21000); //21000
		
		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()&&http.responseCode!=0) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"TimeOut");	
			dohtmlfile(target,http.responseCode + ".html");
		}
		
	}
	
	static void runBadHost(String target) {
		String comments = new String();
		http.httpThroguhSocket(target,80, "GET / HTTP/1.1\r\nhost: 192.168.1.1\r\n",0);

		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"BadHost");	
			dohtmlfile(target,http.responseCode + ".html");
		}
		
	}
	
	static void runBadVersion(String target) {
		String comments = new String();
		http.httpThroguhSocket(target,80, "GET / HTTP/1.2\r\nhost: " + target + "\r\n",0);

		if (!new File("project\\" + controller.projectname + "\\" + target + "\\" + http.responseCode + ".html").exists()) {		
			checkServerString(http.responseServer);
			writeSummary(target,comments,"BadVersion");	
			dohtmlfile(target,http.responseCode + ".html");
		}
		
	}

	static void run() {
		
		Scanner input = new Scanner(System.in);
		String timeout = new String();
		
		System.out.println("Do you want to run TimeOut group requests? It takes 21 seconds per server [Yes] [No]");
		timeout = input.next(); 
		
		int i=0;
		String path = "project\\" + controller.projectname + "\\";
		
		try { errorsummary = new PrintWriter(path + "\\errors-summary"); } 
		catch (FileNotFoundException e1) { e1.printStackTrace(); }
		errorsummary.print("target");
		errorsummary.print(",");
		errorsummary.print("tested code");
		errorsummary.print(",");
		errorsummary.print("http code recevied");
		errorsummary.print(",");
		errorsummary.print("server banner");
		errorsummary.print(",");
		errorsummary.print("server version");
		errorsummary.print(",");
		errorsummary.println("comments");
		
		while (i<controller.targets.size()) {
			
			System.out.println("Running httperror for server " + controller.targets.elementAt(i));
			runStandardRequest(controller.targets.elementAt(i));
			runNotFound(controller.targets.elementAt(i));
			runMethodNotValid(controller.targets.elementAt(i));
			runBadRequest(controller.targets.elementAt(i));
			runBadHost(controller.targets.elementAt(i));
			runBadVersion(controller.targets.elementAt(i));
			if (timeout.contains("Yes")||timeout.contains("yes")) runTimeOut(controller.targets.elementAt(i));
			i++;

		}
		errorsummary.close();
		input.close();
	
		
	}
	
	
	
	public static void main(String[] args) {
		run();
		
	}
	
	
}
